<?php

namespace App\Validator\Constraints;

use App\Model\OrganizationalUnitClassroomP2pModes;
use App\Model\UserGroupPermissions;
use Symfony\Component\Validator\Constraint;
use Symfony\Component\Validator\ConstraintValidator;

class OrganizationalUnitClassroomMulticastPortValidator extends ConstraintValidator
{
    CONST int minPort = 9000;
    CONST int maxPort = 9050;

    public function validate($value, Constraint $constraint): void
    {
        if (null === $value) {
            return;
        }

        if (!(self::minPort <= $value) && ($value <= self::maxPort)) {
            $this->context->buildViolation($constraint->message)->addViolation();
            return;
        }
    }
}